CF 1986D. Mathematical Problem

原题链接: Problem - 1986D - Codeforces

**题意:**一串长度最多为20的由数字组成的字符串,在这些数字中间可以添加字符串长度减去二数量的符号,加或者乘,例如1234,就可以添加加号或者乘号二个,变成1+2*34,1*2*34,12+2*3等等,求算出来的最小值。

**思路:**观察可以得到,对于每个字符串,都会有一个数字由二个字符组成,并且这二个字符为相邻字符,所以可以枚举这个数字的位置,然后求出每次的最小值,然后取最小。

cpp 复制代码
//冷静,冷静,冷静
//调不出来就重构
#pragma GCC optimize(2)
#pragma GCC optimize("O3")
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pii;
const int N=1e6+10,mod=998244353;
ll n;string s;
int main()
{
	ios::sync_with_stdio(0),cin.tie(0),cout.tie(0);
	ll t;cin>>t;
	while(t--)
	{
		cin>>n;
		cin>>s;
		ll k=n-2;
		if(k<=0)
		{
			bool l=0;
			for(int i=0;i<s.size();i++)
			{
				if(s[i]!='0')l=1;
                if(i==s.size()-1)l=1;
				if(l)cout<<s[i];
			}
			cout<<endl;
			continue;
		}
		map<ll,ll> op;
		for(int i=0;i<s.size();i++)
		{
			op[s[i]-'0']++;
		}
		ll min1=1e18;
		for(int i=0;i+1<s.size();i++)
		{
			ll sum=1e18;//因为sum可能变成0
			ll zhi=(s[i]-'0')*10+s[i+1]-'0';
			op[s[i]-'0']--;op[s[i+1]-'0']--;
			op[zhi]++;
			for(auto v:op)
			{
				for(int j=0;j<v.second;j++)
				{
					if(sum==1e18)
					{
						sum=v.first;
					}
					else
					{
						sum=min(sum+v.first,sum*v.first);
					}
				}
			}
			min1=min(min1,sum);
			op[zhi]--;
			op[s[i]-'0']++;op[s[i+1]-'0']++;
		}
		cout<<min1<<endl;
	}
    return 0;
}
相关推荐
171320330计算机毕设编程1 小时前
计算机毕业设计 基于YOLO改进算法的车辆特征识别系统设计与实现--lw
java·大数据·python·sql·算法
姜鱼问生1 小时前
Nginx gzip 压缩:一个配置让页面加载快 3 倍
后端·算法·架构
不会就选b1 小时前
算法日常・每日刷题--<动态规划>23
算法·动态规划
GreatSQL社区2 小时前
主从复制SQL线程中断——字符集砸出的坑
java·数据库·算法
Tisfy3 小时前
LeetCode 2333.最小差值平方和:排序 + 数学计算(不用二分)
数学·算法·leetcode·题解·贪心·排序
aqiu1111113 小时前
【C++算法打怪专栏】LeetCode 217. 存在重复元素(解法总结)
c++·算法·leetcode
yi0114 小时前
DAY28: LeetCode 111. 二叉树的最小深度
人工智能·笔记·python·算法·leetcode·二叉树·递归
wuyk5554 小时前
27.LeetCode 2265. 统计值等于子树平均值的节点数 —— 后序遍历实战
stm32·单片机·嵌入式硬件·算法
xiangyun614 小时前
C++ list 模拟实现(二):const迭代器与反向迭代器,模板的黑魔法
开发语言·数据库·c++·算法·stl·list